create or replace PROCEDURE PEDIDOS_PRODUCAO
(
   P_NRPLANPROD IN PLANPRODUCAO.NRPLANPROD%TYPE,
   P_NRORG IN NUMBER,
   P_NRLOGMATPRIMA OUT NUMBER
) AS
 
V_CONF_A_UTILIZAR   NUMBER;
V_CDCNFDISTEMBSERV  VARCHAR2(5);
V_CDCONTAINER       VARCHAR2(5);
V_VRQTDEPRATEMB     NUMBER; 
V_PONTUACAO         NUMBER;
V_SEQUENCIAL        VARCHAR2(20);
V_EXISTELOGMATPRIMA NUMBER;

BEGIN
 FOR C_PTO_ENTREGA IN(
        SELECT CP.NRPLANPROD, CP.CDPRODUTO, P.NMPRODUTO, CP.IDCOOKCHILL, CP.IDTPPRODCHILL, CP.IDESTADO, CP.CDPRATO, CP.CDFILAUXPRAT, CP.CDFILIAL, CP.CDSERVFILI, 
             CP.DTCONSUMO, CP.CDCLIENTE, CP.CDDESTFILI, CP.CDTIPOPRAT, CP.QTCOMESTICLI, CP.NRSEQPRATCAR,
             ROUND((PF.QTAPRODUZIR /PF.QTCOMENSSERV) *  CP.QTCOMESTICLI,5) AS QTAPRODUZIR,
             ROUND((PF.QTEXTRA /PF.QTCOMENSSERV) * CP.QTCOMESTICLI,5) AS QTEXTRA
        FROM CARDACLIPLANPROD CP INNER JOIN (SELECT NRPLANPROD, CDPRODACABADO, SUM(QTAPRODUZIR - QTPERDA) AS QTAPRODUZIR, SUM(QTEXTRA) AS QTEXTRA, 
                                                    SUM(QTCOMENSSERV) QTCOMENSSERV, CDFILIAGREG, CDSERVFILIAGREG, DTCONSUMO, IDCOOKCHILL, 
                                                    IDTPPRODCHILL, IDESTADO, NRORG
                                               FROM PLANPRODFILIAGREGA 
                                              WHERE NRORG = P_NRORG AND 
                                                    NRPLANPROD = P_NRPLANPROD AND 
                                                    IDPRODUZIR = 'S' AND 
                                                    (IDCONCLUIDO = 'N' OR (IDESTADO = 'FINALIZACAO' AND IDFINALIZACAO = 'M')) AND
                                                    QTAPRODUZIR > 0
                                            GROUP BY NRPLANPROD, CDPRODACABADO, CDFILIAGREG, CDSERVFILIAGREG, DTCONSUMO, IDCOOKCHILL, 
                                                     IDTPPRODCHILL, IDESTADO, NRORG) PF ON CP.NRPLANPROD = PF.NRPLANPROD AND 
                                                                                           CP.CDFILIAL = PF.CDFILIAGREG AND
                                                                                           CP.CDSERVFILI = PF.CDSERVFILIAGREG AND
                                                                                           CP.DTCONSUMO = PF.DTCONSUMO AND
                                                                                           PF.NRORG = CP.NRORG AND
                                                                                           PF.CDPRODACABADO = CP.CDPRODUTO AND
                                                                                           CP.IDCOOKCHILL = PF.IDCOOKCHILL AND
                                                                                           CP.IDTPPRODCHILL = PF.IDTPPRODCHILL AND
                                                                                           CP.IDESTADO = PF.IDESTADO
       INNER JOIN PRODUTO P ON P.CDPRODUTO = CP.CDPRODUTO
       WHERE CP.NRPLANPROD = P_NRPLANPROD
    ) LOOP
          BEGIN
          SELECT MAX(CONF_A_UTILIZAR)
                    INTO V_CONF_A_UTILIZAR
                 FROM
                 (
                   /*VERIFICA SE H CONFIGURAO DE EMBALAGENS PARA O SERVIO*/
                   SELECT 1 AS CONF_A_UTILIZAR
                   FROM DUAL
                   WHERE EXISTS
                   (
                     SELECT 1
                     FROM CNFDISTEMBSERV
                     WHERE CDFILIAL = C_PTO_ENTREGA.CDFILIAL 
                     AND CDSERVFILI = C_PTO_ENTREGA.CDSERVFILI
                     AND CDCLIENTE IS NULL 
                   )

                   UNION
                   /*VERIFICA SE H CONFIGURAO DE EMBALAGENS PARA O PONTO DE ENTREGA*/
                   SELECT 2 AS CONF_A_UTILIZAR
                   FROM DUAL
                   WHERE EXISTS
                   (
                     SELECT 1
                     FROM CNFDISTEMBSERV
                     WHERE CDFILIAL = C_PTO_ENTREGA.CDFILIAL 
                       AND CDSERVFILI = C_PTO_ENTREGA.CDSERVFILI
                       AND CDCLIENTE = C_PTO_ENTREGA.CDCLIENTE
                       AND CDDESTFILI = C_PTO_ENTREGA.CDDESTFILI
                   )
                 ) S;
              EXCEPTION
                 WHEN NO_DATA_FOUND THEN
                    /*Indica que no h configurao a ser utilizada*/
                    V_CONF_A_UTILIZAR := 0;
              END;

              IF (V_CONF_A_UTILIZAR = 1) THEN
                BEGIN
                    SELECT CNF.CDCNFDISTEMBSERV, CNF.CDCONTAINER, C.VRQTDEPRATEMB
                      INTO V_CDCNFDISTEMBSERV, V_CDCONTAINER, V_VRQTDEPRATEMB
                      FROM CNFDISTEMBSERV CNF INNER JOIN (SELECT R.CDCONTAINER, R.VRQTDEPRATEMB
                                                           FROM RELPRATEMB R 
                                                           INNER JOIN CONTAINER C ON C.CDCONTAINER = R.CDCONTAINER AND
                                                                                     R.CDFILAUXPRAT = C_PTO_ENTREGA.CDFILAUXPRAT AND
                                                                                     R.CDPRATO = C_PTO_ENTREGA.CDPRATO AND
                                                                                     C.IDPROPOSITO = 'C') C ON C.CDCONTAINER = CNF.CDCONTAINER
                     WHERE CDFILIAL = C_PTO_ENTREGA.CDFILIAL
                       AND CDSERVFILI = C_PTO_ENTREGA.CDSERVFILI
                       AND CDCLIENTE IS NULL
                       AND V_CONF_A_UTILIZAR = 1
                       AND CNF.NRSEQCNFCARD = C_PTO_ENTREGA.NRSEQPRATCAR;
                 EXCEPTION
                    WHEN NO_DATA_FOUND THEN
                       V_CDCONTAINER := NULL;
                 END;
                 IF (V_CDCONTAINER IS NULL) THEN
                    /*DIST AUTOMATICA*/
                    /*RETORNA O CONTAINER DE MENOR PONTUACAO, OU SEJA, AQUELE QUE UTILIZA MENOS EMBALAGENS E QUE TEM MAIOR PERCENTUAL DE OCUPACAO  */
                    BEGIN
                       SELECT CDCONTAINER, VRQTDEPRATEMB, PONTUACAO 
                         INTO V_CDCONTAINER, V_VRQTDEPRATEMB, V_PONTUACAO
                        FROM(SELECT A.CDCONTAINER, VRQTDEPRATEMB, MIN(A.QTEMBCOMPLETAS + A.QTNAOAPROVEITAMENTO) AS PONTUACAO 
                               FROM(SELECT R.CDCONTAINER, CASE TRUNC(C_PTO_ENTREGA.QTAPRODUZIR +  C_PTO_ENTREGA.QTEXTRA / VRQTDEPRATEMB) WHEN 0 THEN 1 ELSE TRUNC(C_PTO_ENTREGA.QTAPRODUZIR +  C_PTO_ENTREGA.QTEXTRA / VRQTDEPRATEMB) END AS QTEMBCOMPLETAS,
                                           VRQTDEPRATEMB, CASE MOD(C_PTO_ENTREGA.QTAPRODUZIR +  C_PTO_ENTREGA.QTEXTRA , VRQTDEPRATEMB) 
                                                          WHEN 0 THEN 0 ELSE (1 - ((VRQTDEPRATEMB - MOD(C_PTO_ENTREGA.QTAPRODUZIR +  C_PTO_ENTREGA.QTEXTRA , VRQTDEPRATEMB)) / VRQTDEPRATEMB)) END AS QTNAOAPROVEITAMENTO
                                      FROM RELPRATEMB R INNER JOIN CONTAINER C ON R.CDCONTAINER = C.CDCONTAINER AND C.IDPROPOSITO = 'C'
                                     WHERE CDPRATO = C_PTO_ENTREGA.CDPRATO AND
                                           CDFILAUXPRAT = C_PTO_ENTREGA.CDFILAUXPRAT) A
                               GROUP BY A.CDCONTAINER,VRQTDEPRATEMB
                               ORDER BY MIN(A.QTEMBCOMPLETAS + A.QTNAOAPROVEITAMENTO))
                       WHERE ROWNUM = 1;
                    EXCEPTION
                       WHEN NO_DATA_FOUND THEN
                          V_CDCONTAINER := NULL;
                          V_VRQTDEPRATEMB := NULL;
                          V_CONF_A_UTILIZAR := NULL;
                    END;    
                 END IF;

                 UPDATE CARDACLIPLANPROD 
                    SET QTAPRODUZIR = C_PTO_ENTREGA.QTAPRODUZIR,
                        QTEXTRA = C_PTO_ENTREGA.QTEXTRA,
                        CDCONTAINER = V_CDCONTAINER,
                        VRQTDEPRATEMB = V_VRQTDEPRATEMB
                  WHERE NRPLANPROD = C_PTO_ENTREGA.NRPLANPROD AND
                        CDPRODUTO = C_PTO_ENTREGA.CDPRODUTO AND
                        IDCOOKCHILL = C_PTO_ENTREGA.IDCOOKCHILL AND
                        IDTPPRODCHILL = C_PTO_ENTREGA.IDTPPRODCHILL AND
                        IDESTADO = C_PTO_ENTREGA.IDESTADO AND
                        CDPRATO = C_PTO_ENTREGA.CDPRATO AND
                        CDFILAUXPRAT = C_PTO_ENTREGA.CDFILAUXPRAT AND
                        CDFILIAL = C_PTO_ENTREGA.CDFILIAL AND
                        CDSERVFILI = C_PTO_ENTREGA.CDSERVFILI AND
                        DTCONSUMO = C_PTO_ENTREGA.DTCONSUMO AND
                        (CDCLIENTE = C_PTO_ENTREGA.CDCLIENTE OR CDCLIENTE IS NULL) AND
                        (CDDESTFILI = C_PTO_ENTREGA.CDDESTFILI OR CDDESTFILI IS NULL) AND
                        CDTIPOPRAT = C_PTO_ENTREGA.CDTIPOPRAT AND
                        NRSEQPRATCAR = C_PTO_ENTREGA.NRSEQPRATCAR;
              ELSIF (V_CONF_A_UTILIZAR = 2) THEN
                 BEGIN
                   SELECT CNF.CDCNFDISTEMBSERV, CNF.CDCONTAINER, C.VRQTDEPRATEMB
                     INTO V_CDCNFDISTEMBSERV, V_CDCONTAINER, V_VRQTDEPRATEMB
                     FROM CNFDISTEMBSERV CNF INNER JOIN (SELECT R.CDCONTAINER, R.VRQTDEPRATEMB
                                                          FROM RELPRATEMB R 
                                                          INNER JOIN CONTAINER C ON C.CDCONTAINER = R.CDCONTAINER AND
                                                                                    R.CDFILAUXPRAT = C_PTO_ENTREGA.CDFILAUXPRAT AND
                                                                                    R.CDPRATO = C_PTO_ENTREGA.CDPRATO AND
                                                                                    C.IDPROPOSITO = 'C') C ON C.CDCONTAINER = CNF.CDCONTAINER
                    WHERE CDFILIAL = C_PTO_ENTREGA.CDFILIAL
                      AND CDSERVFILI = C_PTO_ENTREGA.CDSERVFILI
                      AND CDCLIENTE = C_PTO_ENTREGA.CDCLIENTE
                      AND CDDESTFILI = C_PTO_ENTREGA.CDDESTFILI
                      AND V_CONF_A_UTILIZAR = 2;
                  EXCEPTION WHEN NO_DATA_FOUND THEN
                    V_CDCONTAINER := NULL;
                  END;

                     IF (V_CDCONTAINER IS NULL) THEN
                        /*DIST AUTOMATICA*/
                        /*RETORNA O CONTAINER DE MENOR PONTUACAO, OU SEJA, AQUELE QUE UTILIZA MENOS EMBALAGENS E QUE TEM MAIOR PERCENTUAL DE OCUPACAO  */
                        BEGIN 
                            SELECT CDCONTAINER, VRQTDEPRATEMB, PONTUACAO 
                              INTO V_CDCONTAINER, V_VRQTDEPRATEMB, V_PONTUACAO
                             FROM(SELECT A.CDCONTAINER, VRQTDEPRATEMB, MIN(A.QTEMBCOMPLETAS + A.QTNAOAPROVEITAMENTO) AS PONTUACAO 
                                    FROM(SELECT R.CDCONTAINER, CASE TRUNC(C_PTO_ENTREGA.QTAPRODUZIR +  C_PTO_ENTREGA.QTEXTRA / VRQTDEPRATEMB) WHEN 0 THEN 1 ELSE TRUNC(C_PTO_ENTREGA.QTAPRODUZIR +  C_PTO_ENTREGA.QTEXTRA / VRQTDEPRATEMB) END AS QTEMBCOMPLETAS,
                                                VRQTDEPRATEMB, CASE MOD(C_PTO_ENTREGA.QTAPRODUZIR +  C_PTO_ENTREGA.QTEXTRA , VRQTDEPRATEMB) 
                                                               WHEN 0 THEN 0 ELSE (1 - ((VRQTDEPRATEMB - MOD(C_PTO_ENTREGA.QTAPRODUZIR +  C_PTO_ENTREGA.QTEXTRA , VRQTDEPRATEMB)) / VRQTDEPRATEMB)) END AS QTNAOAPROVEITAMENTO
                                           FROM RELPRATEMB R INNER JOIN CONTAINER C ON R.CDCONTAINER = C.CDCONTAINER AND C.IDPROPOSITO = 'C'
                                          WHERE CDPRATO = C_PTO_ENTREGA.CDPRATO AND
                                                CDFILAUXPRAT = C_PTO_ENTREGA.CDFILAUXPRAT) A
                                    GROUP BY A.CDCONTAINER,VRQTDEPRATEMB
                                    ORDER BY MIN(A.QTEMBCOMPLETAS + A.QTNAOAPROVEITAMENTO))
                            WHERE ROWNUM = 1;
                         EXCEPTION WHEN NO_DATA_FOUND THEN
                           V_CDCONTAINER := NULL;
                           V_VRQTDEPRATEMB := NULL;
                           V_CONF_A_UTILIZAR := NULL;
                         END;

                         UPDATE CARDACLIPLANPROD 
                            SET QTAPRODUZIR = C_PTO_ENTREGA.QTAPRODUZIR,
                                QTEXTRA = C_PTO_ENTREGA.QTEXTRA,
                                CDCONTAINER = V_CDCONTAINER,
                                VRQTDEPRATEMB = V_VRQTDEPRATEMB
                          WHERE NRPLANPROD = C_PTO_ENTREGA.NRPLANPROD AND
                                CDPRODUTO = C_PTO_ENTREGA.CDPRODUTO AND
                                IDCOOKCHILL = C_PTO_ENTREGA.IDCOOKCHILL AND
                                IDTPPRODCHILL = C_PTO_ENTREGA.IDTPPRODCHILL AND
                                IDESTADO = C_PTO_ENTREGA.IDESTADO AND
                                CDPRATO = C_PTO_ENTREGA.CDPRATO AND
                                CDFILAUXPRAT = C_PTO_ENTREGA.CDFILAUXPRAT AND
                                CDFILIAL = C_PTO_ENTREGA.CDFILIAL AND
                                CDSERVFILI = C_PTO_ENTREGA.CDSERVFILI AND
                                DTCONSUMO = C_PTO_ENTREGA.DTCONSUMO AND
                                (CDCLIENTE = C_PTO_ENTREGA.CDCLIENTE OR CDCLIENTE IS NULL) AND
                                (CDDESTFILI = C_PTO_ENTREGA.CDDESTFILI OR CDDESTFILI IS NULL) AND
                                CDTIPOPRAT = C_PTO_ENTREGA.CDTIPOPRAT AND
                                NRSEQPRATCAR = C_PTO_ENTREGA.NRSEQPRATCAR;
                        END IF;
                  END IF;

                  IF (V_CONF_A_UTILIZAR = 0 OR V_CONF_A_UTILIZAR IS NULL) THEN
                    IF V_EXISTELOGMATPRIMA IS NULL THEN 
                        NOVO_CODIGO_SC('LOGMATPRIMA', V_SEQUENCIAL);
                        V_EXISTELOGMATPRIMA := V_SEQUENCIAL;
                    END IF;

                    BEGIN
                       SELECT DISTINCT NRLOGMATPRIMA INTO V_EXISTELOGMATPRIMA 
                        FROM LOGMATPRIMA
                       WHERE CDPRODUTO = C_PTO_ENTREGA.CDPRODUTO
						 AND CDFILIAL = C_PTO_ENTREGA.CDFILIAL
                         AND CDSERVFILI = C_PTO_ENTREGA.CDSERVFILI
                         AND DSORIGEM = 'PEDIDO' 
                         AND NRPLANPROD = C_PTO_ENTREGA.NRPLANPROD;
                    EXCEPTION
                        WHEN NO_DATA_FOUND THEN
                        INSERT INTO LOGMATPRIMA 
                            (NRLOGMATPRIMA, CDPRODUTO, NMPRODUTO, DSORIGEM, 
                            CDFILIAL, CDSERVFILI, NRPLANPROD, DTCARDAPIO) 
                          VALUES 
                            (V_EXISTELOGMATPRIMA, C_PTO_ENTREGA.CDPRODUTO, C_PTO_ENTREGA.NMPRODUTO, 'PEDIDO', 
                            C_PTO_ENTREGA.CDFILIAL, C_PTO_ENTREGA.CDSERVFILI, C_PTO_ENTREGA.NRPLANPROD, TO_CHAR(C_PTO_ENTREGA.DTCONSUMO, 'DD/MM/YYYY'));
                    END;
                  END IF;
              END LOOP;
          P_NRLOGMATPRIMA := V_EXISTELOGMATPRIMA;
        END;
/	

create or replace PROCEDURE VALIDA_PLANEJAMENTO_PRODUCAO (
P_CDCENTRAL IN FILIAL.CDFILIAL%TYPE,
P_NRPLANPROD IN PLANPRODUCAO.NRPLANPROD%TYPE,
P_DTPRODUCAO IN PLANPRODUCAO.DTPRODUCAO%TYPE,
P_NRLISTA IN LISTA.NRLISTA%TYPE,
P_VALIDA_ESTOQUE VARCHAR2,
P_NRORG IN PLANPRODUCAO.NRORG%TYPE,
P_RETORNO OUT VARCHAR2
) AS


V_PRIMEIROLOOP NUMBER;
V_NRLISTA VARCHAR2(20);
V_RETORNO VARCHAR2(50);
V_NMPRODACABADO VARCHAR2(4000);

BEGIN
   V_PRIMEIROLOOP := 0;
   V_NRLISTA := '';
   V_RETORNO := '';
   
   /*PROCURA PRODUTOS JA PRODUZIDOS EM OUTRO PLANEJAMENTO DA PRODUCAO COM A MESMA DATA DE PRODUO, SE ENCONTRAR INSERE NA TABELA LISTA*/
   FOR C_PROD_JA_PRODUZIDOS IN (SELECT DISTINCT PD.CDPRODACABADO||SUBSTR(PD.IDCOOKCHILL,1,1)||SUBSTR(PD.IDFINALIZACAO,1,1)
                                      ||SUBSTR(PD.IDTPPRODCHILL,1,1)||SUBSTR(PD.IDESTADO,1,1) AS PRODUTO  
                                  FROM PLANPRODFILIAGREGA PD INNER JOIN (SELECT NRPLANPROD, DTPRODUCAO 
                                                                        FROM PLANPRODUCAO 
                                                                       WHERE CDFILIAL = P_CDCENTRAL 
                                                                         AND DTPRODUCAO = P_DTPRODUCAO) PP ON (PP.NRPLANPROD = PD.NRPLANPROD)
                                                           INNER JOIN PLANPRODFILIAGREGA PPA ON (PPA.CDPRODACABADO = PD.CDPRODACABADO AND
                                                                                  PPA.IDCOOKCHILL = PD.IDCOOKCHILL AND
                                                                                  PPA.IDFINALIZACAO = PD.IDFINALIZACAO AND
                                                                                  PPA.IDTPPRODCHILL = PD.IDTPPRODCHILL AND
                                                                                  PPA.IDESTADO = PD.IDESTADO AND
                                                                                  PPA.CDFILIAGREG = PD.CDFILIAGREG AND
                                                                                  PPA.CDSERVFILIAGREG = PD.CDSERVFILIAGREG AND
                                                                                  PPA.DTCONSUMO = PD.DTCONSUMO AND 
                                                                                  PPA.NRPLANPROD = P_NRPLANPROD)
                                                           INNER JOIN LISTA L ON (L.NRLISTA = P_NRLISTA AND
                                                                                  SUBSTR(L.CDLISTA,1,10) = PD.CDPRODACABADO AND
                                                                                  SUBSTR(L.CDLISTA,11,1) = SUBSTR(PD.IDCOOKCHILL,1,1)   AND
                                                                                  SUBSTR(L.CDLISTA,12,1) = SUBSTR(PD.IDFINALIZACAO,1,1) AND
                                                                                  SUBSTR(L.CDLISTA,13,1) = SUBSTR(PD.IDTPPRODCHILL,1,1) AND
                                                                                  SUBSTR(L.CDLISTA,14,1) = SUBSTR(PD.IDESTADO,1,1) AND
                                                                                  PD.IDESTADO <> 'FINALIZACAO')
                                 WHERE PD.NRPLANPROD <> P_NRPLANPROD
                                   AND PD.IDPRODUZIR = 'S'
   )LOOP
      
      IF V_PRIMEIROLOOP = 0 THEN
         NOVO_CODIGO('LISTA', V_NRLISTA, 1);
         V_NRLISTA := SUBSTR(V_NRLISTA, 11, 10);
         V_PRIMEIROLOOP := 1;
      END IF;
  
      INSERT INTO LISTA(CDLISTA, NRLISTA) VALUES (C_PROD_JA_PRODUZIDOS.PRODUTO,  V_NRLISTA);
      
      DELETE FROM LISTA WHERE NRLISTA = P_NRLISTA AND SUBSTR(CDLISTA,1,14) = C_PROD_JA_PRODUZIDOS.PRODUTO;
      
   END LOOP;
   
   V_RETORNO := V_NRLISTA;
   
   /*SE VALIDA POSICAO DE ESTOQUE DA MATERIA PRIMA, PROCURA SE EXISTE PRODUTO COM SALDO INSUFICIENTE NO ESTOQUE, SE SIM INSERE NO LOGMAT_PRIMA*/ 
   IF (P_VALIDA_ESTOQUE = 'S') THEN 
      V_PRIMEIROLOOP := 0;
      FOR POS_ESTOQUE IN(
      SELECT PROD.CDPRODUTO, PROD.QTAPRODUZIR + PROD.QTRESERVADA AS QTNECESSARIA, PROD.QTRESERVADA, NVL(PS.QTESTDIACON,0) AS QTESTDIACON FROM
      (SELECT SUM(QTLIBERADA) AS QTAPRODUZIR, SUM(QTRESERVADA) AS QTRESERVADA, CDPRODUTO, NRORG FROM (
         SELECT QTLIBERADA, 0 AS QTRESERVADA, CDPRODUTO, PR.NRORG
           FROM PLANRECPROD PR INNER JOIN LISTA L ON (L.NRLISTA = P_NRLISTA AND
                                                      SUBSTR(L.CDLISTA,1,10) = PR.CDPRODACABADO AND
                                                      SUBSTR(L.CDLISTA,11,1) = SUBSTR(IDCOOKCHILL,1,1)   AND
                                                      SUBSTR(L.CDLISTA,12,1) = SUBSTR(IDFINALIZACAO,1,1) AND
                                                      SUBSTR(L.CDLISTA,13,1) = SUBSTR(IDTPPRODCHILL,1,1) AND
                                                      SUBSTR(L.CDLISTA,14,1) = SUBSTR(IDESTADO,1,1) AND
                                                      SUBSTR(L.CDLISTA, 15)  = PR.NRSEQPRODACABADO AND
                                                      PR.IDESTADO <> 'FINALIZACAO' AND
                                                      PR.NRPLANPROD = P_NRPLANPROD AND
                                                      PR.CDFILIAL = P_CDCENTRAL)
         UNION ALL
         SELECT 0 AS QTAPRODUZIR, PR.QTLIBERADA AS QTRESERVADA, CDPRODUTO, PR.NRORG
           FROM PLANRECPROD PR INNER JOIN LISTA L ON (L.NRLISTA = P_NRLISTA AND
                                                      SUBSTR(L.CDLISTA,1,10) = PR.CDPRODACABADO AND
                                                      SUBSTR(L.CDLISTA,11,1) = SUBSTR(IDCOOKCHILL,1,1)   AND
                                                      SUBSTR(L.CDLISTA,12,1) = SUBSTR(IDFINALIZACAO,1,1) AND
                                                      SUBSTR(L.CDLISTA,13,1) = SUBSTR(IDTPPRODCHILL,1,1) AND
                                                      SUBSTR(L.CDLISTA,14,1) = SUBSTR(IDESTADO,1,1) AND
                                                      SUBSTR(L.CDLISTA, 15)  = PR.NRSEQPRODACABADO AND
                                                      PR.IDESTADO <> 'FINALIZACAO' AND
                                                      PR.CDFILIAL = P_CDCENTRAL)
                               INNER JOIN (SELECT CDFILIAL, NRPLANPROD, DTPRODUCAO 
                                             FROM PLANPRODUCAO 
                                            WHERE CDFILIAL = P_CDCENTRAL 
                                              AND DTPRODUCAO = P_DTPRODUCAO
                                              AND NRPLANPROD <> P_NRPLANPROD) PP ON (PP.NRPLANPROD = PR.NRPLANPROD AND PR.CDFILIAL = PP.CDFILIAL)
                               INNER JOIN PLANPRODFILIAGREGA PF ON PF.NRPLANPROD = PR.NRPLANPROD AND
                                                                   PF.CDPRODACABADO = PR.CDPRODACABADO AND
                                                                   PF.NRSEQPRODACABADO = PR.NRSEQPRODACABADO AND
                                                                   PF.CDFILIAGREG = PR.CDFILIAGREG AND
                                                                   PF.CDSERVFILIAGREG = PR.CDSERVFILIAGREG AND
                                                                   PF.DTCONSUMO = PR.DTCONSUMO AND
                                                                   PF.IDCOOKCHILL = PR.IDCOOKCHILL AND
                                                                   PF.IDTPPRODCHILL = PR.IDTPPRODCHILL AND
                                                                   PF.IDESTADO = PR.IDESTADO AND
                                                                   PF.IDFINALIZACAO = PR.IDFINALIZACAO AND
                                                                   PF.IDPRODUZIR = 'S' AND PF.IDCONCLUIDO = 'N' AND
                                                                   PF.NRPLANPROD = PP.NRPLANPROD)
         GROUP BY CDPRODUTO, NRORG) PROD LEFT JOIN (SELECT PC.CDPRODUTO, PC.QTESTDIACON
                                                      FROM POSESTCONS PC
                                                     WHERE PC.NRORG = P_NRORG
                                                       AND PC.CDFILIAL = P_CDCENTRAL
                                                       AND PC.DTPOSESTCON = (SELECT MAX(P.DTPOSESTCON)
                                                                               FROM POSESTCONS P
                                                                              WHERE P.CDFILIAL = P_CDCENTRAL
                                                                                AND P.CDPRODUTO = PC.CDPRODUTO
                                                                                AND P.DTPOSESTCON <= TO_DATE(P_DTPRODUCAO) + 1
                                                                                AND P.NRORG = P_NRORG
                                                                             )
                                                    ) PS ON (PS.CDPRODUTO = PROD.CDPRODUTO)   
      WHERE PROD.QTAPRODUZIR >  NVL(PS.QTESTDIACON,0) - PROD.QTRESERVADA
      ) LOOP
      
         IF V_PRIMEIROLOOP = 0 THEN
            DELETE FROM LOGMATPRIMA WHERE NRPLANPROD = P_NRPLANPROD AND NRORG = P_NRORG AND DSORIGEM = 'PLANEJAMENTO' AND DSJUSTIFICATIVA IS NULL;
            
            NOVO_CODIGO('LOGMATPRIMA', V_NRLISTA, 1);
            V_NRLISTA := SUBSTR(V_NRLISTA, 11, 10);
            V_PRIMEIROLOOP := 1;
         END IF;
         
         FOR C_PRODACABADO IN (SELECT DISTINCT CDPRODACABADO, NMPRODUTO 
                                 FROM PLANRECPROD R INNER JOIN PRODUTO P ON R.CDPRODACABADO = P.CDPRODUTO 
                                                    INNER JOIN LISTA L ON (L.NRLISTA = P_NRLISTA AND
                                                                           SUBSTR(L.CDLISTA,1,10) = R.CDPRODACABADO AND
                                                                           SUBSTR(L.CDLISTA,11,1) = SUBSTR(R.IDCOOKCHILL,1,1)   AND
                                                                           SUBSTR(L.CDLISTA,12,1) = SUBSTR(R.IDFINALIZACAO,1,1) AND
                                                                           SUBSTR(L.CDLISTA,13,1) = SUBSTR(R.IDTPPRODCHILL,1,1) AND
                                                                           SUBSTR(L.CDLISTA,14,1) = SUBSTR(R.IDESTADO,1,1) AND
                                                                           R.IDESTADO <> 'FINALIZACAO')
                                WHERE R.NRPLANPROD = P_NRPLANPROD AND
                                      R.CDFILIAL = P_CDCENTRAL AND 
                                      R.CDPRODUTO = POS_ESTOQUE.CDPRODUTO AND
                                      ROWNUM < 10)
                                    
        LOOP 
           V_NMPRODACABADO := V_NMPRODACABADO || C_PRODACABADO.CDPRODACABADO || ' - ' || C_PRODACABADO.NMPRODUTO || ' ';  

        END LOOP;

        INSERT INTO LOGMATPRIMA (NRLOGMATPRIMA, CDPRODUTO, NRORG, NRPLANPROD, QTREQUERIDA, QTESTOQUE, DTVALIDACAO, DSORIGEM, DSSTRPRODACAB) VALUES
                                (V_NRLISTA,POS_ESTOQUE.CDPRODUTO, P_NRORG, P_NRPLANPROD, POS_ESTOQUE.QTNECESSARIA, POS_ESTOQUE.QTESTDIACON, 
                                 SYSDATE, 'PLANEJAMENTO',V_NMPRODACABADO);
         V_NMPRODACABADO := '';
         
      END LOOP;
      IF V_PRIMEIROLOOP = 1 THEN
         V_RETORNO := V_RETORNO || '_' || V_NRLISTA;
         DBMS_OUTPUT.PUT_LINE(V_RETORNO);
         P_RETORNO := V_RETORNO;
         RETURN;
      END IF;
   END IF;
   
   /*UPDATE PARA PRODUZIR OS PRODUTOS QUE NO POSSUEM PLOBLEMAS DE ESTOQUE NEM PLANEJAMENTO DIFERENTE JA PRODUZIDO*/
   UPDATE PLANPRODACABADO 
      SET IDPRODUZIR = 'S'
    WHERE CDPRODACABADO||SUBSTR(IDCOOKCHILL,1,1)||SUBSTR(IDFINALIZACAO,1,1)||SUBSTR(IDTPPRODCHILL,1,1)||SUBSTR(IDESTADO,1,1)||NRSEQPRODACABADO IN 
         (SELECT CDLISTA FROM LISTA WHERE NRLISTA = P_NRLISTA)
      AND NRPLANPROD = P_NRPLANPROD;
      
   UPDATE PLANPRODFILIAGREGA 
      SET IDPRODUZIR = 'S'
    WHERE CDPRODACABADO||SUBSTR(IDCOOKCHILL,1,1)||SUBSTR(IDFINALIZACAO,1,1)||SUBSTR(IDTPPRODCHILL,1,1)||SUBSTR(IDESTADO,1,1)||NRSEQPRODACABADO IN 
         (SELECT CDLISTA FROM LISTA WHERE NRLISTA = P_NRLISTA)
      AND NRPLANPROD = P_NRPLANPROD;
      
   DELETE FROM LISTA WHERE NRLISTA = P_NRLISTA;
      
   COMMIT;
   P_RETORNO := V_RETORNO;
    --DBMS_OUTPUT.PUT_LINE(V_RETORNO);
END;